proc SetStatusLabel { text } {

    .main.statusbar.label config -text $text
}

proc resetInnerPointsButton { } {

    .main.edit.draw.inner config -relief raised

    .main.edit.draw.hole config -state normal
    .main.edit.draw.delete config -state normal
}

proc resetHolePointButton { } {

    .main.edit.draw.hole config -relief raised

    .main.edit.draw.inner config -state normal
    .main.edit.draw.delete config -state normal
}

proc resetDeletePointButton { } {

    .main.edit.draw.delete config -relief raised

    .main.edit.draw.hole config -state normal
    .main.edit.draw.inner config -state normal
}

proc getWHXY { } {
    set whxy [wm geom .]

    set i 0
    while { [string index $whxy $i] != "x" } {
	incr i
    }
    set w [string range $whxy 0 [expr $i-1]]

    set j $i
    while { [string index $whxy $j] != "+" } {
	incr j
    }
    set h [string range $whxy [expr $i+1] [expr $j-1]]

    set i [expr $j+1]
    incr j
    while { [string index $whxy $j] != "+" } {
	incr j
    }
    incr j -1

    set x [string range $whxy $i $j]
    set y [string range $whxy [expr $j+2] [string length $whxy]]

    #puts "whxy: $whxy"
    #puts "w h x y: $w $h $x $y"

    return "$w $h $x $y"
}

proc dialogWindow { } {

    # Change the window to only a border
    wm transient .dialog .
    wm withdraw .dialog
    wm overrideredirect .dialog 0
    wm deiconify .dialog

    # Place this window
    set whxy [getWHXY]
    set w [lindex $whxy 0]
    set h [lindex $whxy 1]
    set x [lindex $whxy 2]
    set y [lindex $whxy 3]

    set xx [expr $x + 50]
    set yy [expr $y + 100]
    set xy "+$xx+$yy"    
    wm geom .dialog $xy

#    wm geom .dialog +300+300
}

proc dialogOTTile { } {
    global eOTetra

    toplevel .dialog
    button .dialog.t1 -image ottile1 -command "destroy .dialog; setSymmetryGroup $eOTetra 1"
    button .dialog.t2 -image ottile2 -command "destroy .dialog; setSymmetryGroup $eOTetra 2"
    label .dialog.label -text "Select a tetrahedron tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 2 -ipady 5 -sticky e,w

    dialogWindow
}

proc dialogOOTile { } {
    global eOOcta

    toplevel .dialog
    button .dialog.t1 -image ootile1 -command "destroy .dialog; setSymmetryGroup $eOOcta 1"
    button .dialog.t2 -image ootile2 -command "destroy .dialog; setSymmetryGroup $eOOcta 2"
    button .dialog.t3 -image ootile3 -command "destroy .dialog; setSymmetryGroup $eOOcta 3"
    label .dialog.label -text "Select a octahedron tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.t3 -row 0 -col 2 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 3 -ipady 5 -sticky e,w

    dialogWindow
}

proc dialogOCTile { } {
    global eOCube

    toplevel .dialog
    button .dialog.t1 -image octile1 -command "destroy .dialog; setSymmetryGroup $eOCube 1"
    button .dialog.t2 -image octile2 -command "destroy .dialog; setSymmetryGroup $eOCube 2"
    button .dialog.t3 -image octile3 -command "destroy .dialog; setSymmetryGroup $eOCube 3"
    label .dialog.label -text "Select a cube tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.t3 -row 0 -col 2 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 3 -ipady 5 -sticky e,w

    dialogWindow
}

proc dialogOITile { } {
    global eOIcosa

    toplevel .dialog
    button .dialog.t1 -image oitile1 -command "destroy .dialog; setSymmetryGroup $eOIcosa 1"
    button .dialog.t2 -image oitile2 -command "destroy .dialog; setSymmetryGroup $eOIcosa 2"
    button .dialog.t3 -image oitile3 -command "destroy .dialog; setSymmetryGroup $eOIcosa 3"
    label .dialog.label -text "Select a icosahedron tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.t3 -row 0 -col 2 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 3 -ipady 5 -sticky e,w

    dialogWindow
}

proc dialogODTile { } {
    global eODodeca

    toplevel .dialog
    button .dialog.t1 -image odtile1 -command "destroy .dialog;setSymmetryGroup $eODodeca 1"
    button .dialog.t2 -image odtile2 -command "destroy .dialog;setSymmetryGroup $eODodeca 2"
    button .dialog.t3 -image odtile3 -command "destroy .dialog;setSymmetryGroup $eODodeca 3"
    label .dialog.label -text "Select a dodecahedron tiling" -font {Helvetica 11 bold}

    grid .dialog.t1 -row 0 -col 0 -padx 5 -pady 5
    grid .dialog.t2 -row 0 -col 1 -padx 5 -pady 5
    grid .dialog.t3 -row 0 -col 2 -padx 5 -pady 5
    grid .dialog.label -row 1 -col 0 -columnspan 3 -ipady 5 -sticky e,w

    dialogWindow
}

proc initialize { } {

    initImages
}

proc initImages { } {
    global ottile1 ottile2

    image create photo ottile1 
    ottile1 configure -file "images/ottile1_150.gif"
    
    image create photo ottile2 
    ottile2 configure -file "images/ottile2_150.gif"

    image create photo ootile1
    ootile1 configure -file "images/ootile1_150.gif"

    image create photo ootile2
    ootile2 configure -file "images/ootile2_150.gif"

    image create photo ootile3
    ootile3 configure -file "images/ootile3_150.gif"

    image create photo octile1
    octile1 configure -file "images/octile1_150.gif"

    image create photo octile2
    octile2 configure -file "images/octile2_150.gif"

    image create photo octile3
    octile3 configure -file "images/octile3_150.gif"

    image create photo oitile1
    oitile1 configure -file "images/oitile1_150.gif"

    image create photo oitile2
    oitile2 configure -file "images/oitile2_150.gif"

    image create photo oitile3
    oitile3 configure -file "images/oitile3_150.gif"

    image create photo odtile1
    odtile1 configure -file "images/odtile1_150.gif"

    image create photo odtile2
    odtile2 configure -file "images/odtile2_150.gif"

    image create photo odtile3
    odtile3 configure -file "images/odtile3_150.gif"
}

proc setup {} {
    global eOTetra eSTetra eDTetra eOOcta eSOcta eOCube eSCube eOIcosa eSIcosa 
    global eODodeca eSDodeca ePDodeca eSize

    wm title    . "Escher Sphere"
    wm geometry . +200+200


    frame .main

    #######################
    ### Togl Widget
    frame .main.sphere -relief raised -bd 2

    togl .main.sphere.togl -width 500 -height 500 -rgba true -double true \
	    -depth true -ident Ball 

    grid .main.sphere.togl -row 0 -col 0

    # binding key to .main.sphere.togl doesn't work, must use bind all
    #bind all <KeyPress>   ".main.sphere.togl keyboard %K 0 %x %y"
    #bind all <KeyRelease> ".main.sphere.togl keyboard %K 1 %x %y"

    bind .main.sphere.togl <ButtonPress>   ".main.sphere.togl mouseButton %b 0 %x %y %t"
    bind .main.sphere.togl <ButtonRelease> ".main.sphere.togl mouseButton %b 1 %x %y %t"
    bind .main.sphere.togl <B1-Motion> ".main.sphere.togl mouseMotion 1 %x %y %t"
    bind .main.sphere.togl <B2-Motion> ".main.sphere.togl mouseMotion 2 %x %y %t"
    bind .main.sphere.togl <B3-Motion> ".main.sphere.togl mouseMotion 3 %x %y %t"
    
    bind all <Escape> "exit"

    #######################
    ### Menu Bar
    frame .main.menubar -relief raised -bd 2

    menubutton .main.menubar.file  -text File -underline 0 \
	    -menu .main.menubar.file.menu
    menubutton .main.menubar.group -text "SymmetryGroup" -underline 0 \
	    -menu .main.menubar.group.menu
    menubutton .main.menubar.grid -text "GridOptions" -underline 0 \
	    -menu .main.menubar.grid.menu
    button .main.menubar.camerareset -relief flat -text "CameraReset" -underline 0 \
	    -command {.main.sphere.togl camera 1} -padx 3 -pady 3
    button .main.menubar.pointsize -relief flat -text "PointSize" -underline 0 \
	    -command "zoom" -padx 3 -pady 3

    pack .main.menubar.file .main.menubar.group .main.menubar.grid \
	    .main.menubar.camerareset .main.menubar.pointsize -side left

    set m1 [menu .main.menubar.file.menu -tearoff 0]
    $m1 add command -label "Open"    -command "openES"
    $m1 add command -label "Save"    -command "outputES"
    $m1 add cascade -label "Save As" -menu $m1.saveas
    $m1 add command -label "Quit"    -command exit -accelerator "<Esc>"

    set m1_1 [menu $m1.saveas -tearoff 0]
    $m1_1 add command -label "STL" -command "outputSTL"

    set m2 [menu .main.menubar.group.menu -tearoff 0]
    $m2 add radiobutton -label "Oriented Tetrahedron"  -variable sym -value $eOTetra \
	    -command "dialogOTTile"
    $m2 add radiobutton -label "Straight Tetrahedron"  -variable sym -value $eSTetra \
	    -command "setSymmetryGroup $eSTetra 0"
    $m2 add radiobutton -label "Double Tetrahedron"    -variable sym -value $eDTetra \
	    -command "setSymmetryGroup $eDTetra 0"
    $m2 add radiobutton -label "Oriented Octahedron"   -variable sym -value $eOOcta \
	    -command "dialogOOTile"
#    $m2 add radiobutton -label "Straight Octahedron"  -variable sym -value $eSOcta 
    $m2 add radiobutton -label "Oriented Cube"         -variable sym -value $eOCube \
	    -command "dialogOCTile"
#    $m2 add radiobutton -label "Straight Cube"        -variable sym -value $eSCube 
    $m2 add radiobutton -label "Oriented Icosahedron"  -variable sym -value $eOIcosa \
	    -command "dialogOITile"
#    $m2 add radiobutton -label "Straight Icosahedron" -variable sym -value $eSIcosa 

    $m2 add radiobutton -label "Oriented Dodecahedron" -variable sym -value $eODodeca \
	    -command "dialogODTile"
    $m2 add radiobutton -label "Penta Dodecahedron"    -variable sym -value $ePDodeca \
	    -command "setSymmetryGroup $ePDodeca 0"



    set m3 [menu .main.menubar.grid.menu -tearoff 0]
    $m3 add radiobutton -label "No grid" -variable drawGrid -value 0 \
	    -command {drawGrid 0}
    $m3 add radiobutton -label "Face grid" -variable drawGrid -value 1 \
	    -command {drawGrid 1}
    $m3 add radiobutton -label "Tile grid" -variable drawGrid -value 2 \
	    -command {drawGrid 2}

    global drawGrid
    set drawGrid 1

    global sym
    set sym $eOTetra
    setSymmetryGroup $eOTetra 1

    #######################
    ### Status Bar
    frame .main.statusbar -relief raised -bd 2

    label .main.statusbar.label -text " " -pady 4
    label .main.statusbar.logo1 -text "Escher Sphere" -relief groove
    label .main.statusbar.logo2 -text "Spring 2000" -relief groove

    pack .main.statusbar.label -side left -ipadx 6
    pack .main.statusbar.logo2 -side right -padx 4
    pack .main.statusbar.logo1 -side right

    #######################
    ### Edit Panel

    frame .main.edit -relief raised -bd 2

    label .main.edit.label -text "Drawing Mode" -font {Helvetica 13 bold}

    frame .main.edit.draw

    ### draw
    radiobutton .main.edit.draw.ball   -variable draw -value 0 \
	    -text "sphere" -command "setDraw 0" 
    radiobutton .main.edit.draw.poly   -variable draw -value 1 \
	    -text "polyhedron" -command "setDraw 1"
    radiobutton .main.edit.draw.stereo -variable draw -value 2 \
	    -text "stereographic projection" -command "setDraw 2"
    radiobutton .main.edit.draw.tile   -variable draw -value 3 \
	    -text "triangulated tile" -command "setDraw 3"
    radiobutton .main.edit.draw.solid   -variable draw -value 4 \
	    -text "solid tile" -command "setDraw 4"

    global draw
    set draw 0

    ####
    button .main.edit.draw.inner  -text "Add Inner Points" -command {

        set r [.main.edit.draw.inner cget -relief]

	if { $r == "sunken" } {
	    .main.edit.draw.inner config -relief raised
	    .main.edit.draw.hole config -state normal
	    .main.edit.draw.delete config -state normal
	} else {
	    .main.edit.draw.inner config -relief sunken
	    .main.edit.draw.hole config -state disabled
	    .main.edit.draw.delete config -state disabled
	}

	innerPoints
    }

    button .main.edit.draw.hole  -text "Add Hole Points" -command {

        set r [.main.edit.draw.hole cget -relief]

	if { $r == "sunken" } {
	    .main.edit.draw.hole config -relief raised
	    .main.edit.draw.inner config -state normal
	    .main.edit.draw.delete config -state normal
	} else {
	    .main.edit.draw.hole config -relief sunken
	    .main.edit.draw.inner config -state disabled
	    .main.edit.draw.delete config -state disabled
	}

	holePoint
    }

    button .main.edit.draw.delete  -text "Delete Points" -command {

        set r [.main.edit.draw.delete cget -relief]

	if { $r == "sunken" } {
	    .main.edit.draw.delete config -relief raised
	    .main.edit.draw.inner config -state normal
	    .main.edit.draw.hole config -state normal
	} else {
	    .main.edit.draw.delete config -relief sunken
	    .main.edit.draw.inner config -state disabled
	    .main.edit.draw.hole config -state disabled
	}

	deleteDown
    }

    button .main.edit.draw.deselect  -text "Deselect All" -command {

	deselectInner
    }

    grid .main.edit.draw.poly     -row 0 -col 0 -sticky w   -padx 0  -pady 0

    grid .main.edit.draw.ball     -row 1 -col 0 -sticky w   -padx 0  -pady 0
    grid .main.edit.draw.inner    -row 2 -col 0 -sticky w,e -padx 30
    grid .main.edit.draw.hole     -row 3 -col 0 -sticky w,e -padx 30
    grid .main.edit.draw.delete   -row 4 -col 0 -sticky w,e -padx 30

    grid .main.edit.draw.stereo   -row 5 -col 0 -sticky w   -padx 0  -pady 0

    grid .main.edit.draw.tile     -row 6 -col 0 -sticky w   -padx 0  -pady 0
    grid .main.edit.draw.deselect -row 7 -col 0 -sticky w,e -padx 30

    grid .main.edit.draw.solid    -row 8 -col 0 -sticky w   -padx 0  -pady 0


    ###
    frame .main.edit.solid

    frame .main.edit.solid.extrude
    frame .main.edit.solid.shell

    label .main.edit.solid.extrude.label -text "extrude: "
    radiobutton .main.edit.solid.extrude.inward  -variable extrude -value 0 \
	    -text "outward" -command "setExtrude 0" 
    radiobutton .main.edit.solid.extrude.outward  -variable extrude -value 1 \
	    -text "inward" -command "setExtrude 1" 

    grid .main.edit.solid.extrude.label   -row 0 -col 0 -sticky w
    grid .main.edit.solid.extrude.inward  -row 0 -col 1 -sticky w
    grid .main.edit.solid.extrude.outward -row 0 -col 2 -sticky w

    label .main.edit.solid.shell.label -text "shell: "
    radiobutton .main.edit.solid.shell.spherical  -variable shell -value 0 \
	    -text "spherical" -command "setShell 0" 
    radiobutton .main.edit.solid.shell.detailed  -variable shell -value 1 \
	    -text "detailed" -command "setShell 1" 

    grid .main.edit.solid.shell.label     -row 0 -col 0 -sticky w
    grid .main.edit.solid.shell.spherical -row 0 -col 1 -sticky w
    grid .main.edit.solid.shell.detailed  -row 0 -col 2 -sticky w

    global extrude shell
    set extrude 1
    set shell 1

    label .main.edit.solid.radlabel -text "RADIUS of STL output"
    scale .main.edit.solid.rad -from 0.1 -to 10.0 -variable radius -orient horizontal \
	    -tickinterval 9.9 -resolution 0.01 -command "setRadius"
    label .main.edit.solid.thlabel -text "THICKNESS (as % of radius)"
    scale .main.edit.solid.th -from 0.001 -to 0.999 -variable thickness \
	    -orient horizontal -tickinterval 0.998 -resolution 0.001 \
	    -command "setThickness"

    global thickness radius
    set radius 1.0
    set thickness 0.02

    label .main.edit.solid.foo -text " "

    grid .main.edit.solid.extrude  -row 0 -col 1 -sticky w
    grid .main.edit.solid.shell    -row 1 -col 1 -sticky w

    grid .main.edit.solid.foo      -row 2 -col 0 -padx 10
    grid .main.edit.solid.thlabel  -row 3 -col 1 -sticky w -columnspan 2
    grid .main.edit.solid.th       -row 4 -col 1 -sticky e,w 
    grid .main.edit.solid.radlabel -row 5 -col 1 -sticky w -columnspan 2
    grid .main.edit.solid.rad      -row 6 -col 1 -sticky e,w


    ### .main.edit 

    grid .main.edit.label  -row 0 -col 0 -columnspan 2 -sticky w,e -pady 1
    grid .main.edit.draw   -row 2 -col 0               -sticky w
    grid .main.edit.solid  -row 3 -col 0 -columnspan 2 -sticky w,e -pady 0

    ##########################
    ### layout

    grid .main.menubar    -row 0 -col 0 -columnspan 2       -sticky w,e
    grid .main.sphere     -row 1 -col 0 -ipadx 10 -ipady 10 -sticky n,s
    grid .main.edit       -row 1 -col 1 -ipadx 10 -ipady 5  -sticky w,e,n,s
    grid .main.statusbar  -row 2 -col 0 -columnspan 2 -sticky w,e

    ### main
    grid .main -row 0 -col 0
}

proc main { } {
    global eOTetra eSTetra eDTetra eOOcta eSOcta eOCube eSCube eOIcosa eSIcosa 
    global eODodeca eSDodeca ePDodeca eSize

    set eOTetra  0
    set eSTetra  1
    set eDTetra  2
    set eOOcta   3
    set eSOcta   4
    set eOCube   5
    set eSCube   6
    set eOIcosa  7
    set eSIcosa  8
    set eODodeca 9
    set eSDodeca 10
    set ePDodeca 11
    set eSize    12

    initialize
    setup
    
    update idletasks
    guiCreated
}

#puts "auto_path = $auto_path"
main




