#include "ootile2.h"

//////////////////////////////////////////////////////////////////////
// OOTile2 Class
//

OOTile2::OOTile2()
{
  Vector v1, v2, v3, v4;
  FLOAT f, y1, y2, y3;

  // Tile
  y1 = sin( atan(sqrt(2)) ) / sqrt(3);
  y2 = sqrt(2)/2.0;
  y3 = sqrt(2);

  v1.Set(0.0, y1, 2.0/3.0);
  v2.Set(1.0,  0, 1.0);
  v3.Set(0.5, y2, 0.5);
  v4.Set(0.0, y3, 0.0);

  f = 1.0 / v4.Magnitude();

  v1 *= f;
  v2 *= f;
  v3 *= f;
  v4 *= f;

  // 2D
  m_pt2DTilePoint1.Set(v1[X], v1[Y], v1[Z]);
  m_pt2DTilePoint2.Set(v2[X], v2[Y], v2[Z]);
  m_pt2DTilePoint3.Set(v3[X], v3[Y], v3[Z]);
  m_pt2DTilePoint4.Set(v4[X], v4[Y], v4[Z]);

  Init();
}

OOTile2::~OOTile2()
{
}

///////////////////////////////////////////////////////////////////////////////

VOID OOTile2::FindMatrices(Matrix &m1, Matrix &m2, TilePoint *tpt1)
{
  Vector v;

  if( tpt1->GetType() != tpTILE )
    {
      m1 = tpt1->GetPartnerMatrix();
      m2 = (tpt1->GetPartner())->GetPartnerMatrix();
    }
  else if( tpt1->GetTilePoint() == 1 )
    {
      v.Set(0, sqrt(2)/(2*sqrt(3)), 1/sqrt(3));
      m1.SetRotate(v, DEGTORAD(120));
      m2.SetRotate(v, DEGTORAD(-120));
    }
  else if( tpt1->GetTilePoint() == 2 )
    {
      v.Set(0.5, sqrt(2)/2.0, 0.5);
      m1.SetRotate(v, DEGTORAD(-180));
      m2.SetRotate(v, DEGTORAD(180));
    }
  else if( tpt1->GetTilePoint() == 3 )
    {
      v.Set(0.5, sqrt(2)/2.0, 0.5);
      m1.SetRotate(v, DEGTORAD(180));
      m2.SetRotate(v, DEGTORAD(-180));
    }
  else if( tpt1->GetTilePoint() == 4 )
    {
      v.Set(0, sqrt(2)/(2*sqrt(3)), 1/sqrt(3));
      m1.SetRotate(v, DEGTORAD(-120));
      m2.SetRotate(v, DEGTORAD(120));
    }
  else
    {
      ASSERT(FALSE);
    }
}

///////////////////////////////////////////////////////////////////////////////

VOID OOTile2::OutputES(FILE *fpOutputFile, CHAR *paletteFilename,
		       CHAR *colorFilename)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "ooctahedron tile 2\n\n" );

  m_pTile->OutputES(fpOutputFile);

  fprintf(fpOutputFile, "palettefile %s\n", paletteFilename);
  fprintf(fpOutputFile, "colorindexfile %s\n", colorFilename);
  //OutputESColor(fpOutputFile);
}

