#include "ottile2.h"

//////////////////////////////////////////////////////////////////////
// OTTile2 Class
//

OTTile2::OTTile2()
{
  Vector v1, v2, v3, v4;
  FLOAT f, x2, y1, y2, y3, z;
 
  y1 = 1/sqrt(3);
  x2 = 0.25;            // 0.5 - (0.5*cos(DEGTORAD(60.0)));
  y2 = 1/(4.0*sqrt(3)); // (0.5*sin(DEGTORAD(60.0))) - (1/(2.0*sqrt(3)));
  y3 = -1/(2.0*sqrt(3));
  z  = sqrt(6)/12.0;

  v1.Set(0.0, 0.0, z);
  v2.Set(0.5,  y3, z);
  v3.Set( x2,  y2, z);
  v4.Set(0.0,  y1, z);

  f = 1.0 / v4.Magnitude();

  v1 *= f;
  v2 *= f;
  v3 *= f;
  v4 *= f;

  // 2D
  m_pt2DTilePoint1.Set(v1[X], v1[Y], v1[Z]);
  m_pt2DTilePoint2.Set(v2[X], v2[Y], v2[Z]);
  m_pt2DTilePoint3.Set(v3[X], v3[Y], v3[Z]);
  m_pt2DTilePoint4.Set(v4[X], v4[Y], v4[Z]);

  Init();
}

OTTile2::~OTTile2()
{
}

///////////////////////////////////////////////////////////////////////////////

VOID OTTile2::FindMatrices(Matrix &m1, Matrix &m2, TilePoint *tpt1)
{
  Vector v;

  if( tpt1->GetType() != tpTILE )
    {
      m1 = tpt1->GetPartnerMatrix();
      m2 = (tpt1->GetPartner())->GetPartnerMatrix();
    }
  else if( tpt1->GetTilePoint() == 1 )
    {
      m1.SetRotateZ(DEGTORAD(120));
      m2.SetRotateZ(DEGTORAD(-120));
    }
  else if( tpt1->GetTilePoint() == 2 )
    {
      v.Set(1/sqrt(2), 1/sqrt(6), 1/sqrt(3));
      m1.SetRotate(v, DEGTORAD(-180));
      m2.SetRotate(v, DEGTORAD(180));
    }
  else if( tpt1->GetTilePoint() == 3 )
    {
      v.Set(1/sqrt(2), 1/sqrt(6), 1/sqrt(3));
      m1.SetRotate(v, DEGTORAD(180));
      m2.SetRotate(v, DEGTORAD(-180));
    }
  else if( tpt1->GetTilePoint() == 4 )
    {
      m1.SetRotateZ(DEGTORAD(-120));
      m2.SetRotateZ(DEGTORAD(120));
    }
  else
    {
      ASSERT(FALSE);
    }
}

///////////////////////////////////////////////////////////////////////////////

VOID OTTile2::OutputES(FILE *fpOutputFile, CHAR *paletteFilename,
		       CHAR *colorFilename)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "otetrahedron tile 2\n\n" );

  m_pTile->OutputES(fpOutputFile);

  fprintf(fpOutputFile, "palettefile %s\n", paletteFilename);
  fprintf(fpOutputFile, "colorindexfile %s\n", colorFilename);
  //OutputESColor(fpOutputFile);
}
