#ifndef __PENTADODECAHEDRON_H__
#define __PENTADODECAHEDRON_H__

#include "symmetrygroup.h"

//////////////////////////////////////////////////////////////////////////////
// PentaDodecahedron
//

class PentaDodecahedron : public SymmetryGroup
{

//////////////////////////////////////////////////
// Initialization
//
public:
  PentaDodecahedron();
  virtual ~PentaDodecahedron();

  virtual VOID InitFaceGrid();
  virtual VOID InitTileGrid();

  virtual VOID InitSphereFaceGrid();
  virtual VOID InitSphereTileGrid();
  virtual VOID InitOutline();

  virtual VOID InitFaceMatrices();
  virtual VOID InitTileMatrices();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output
//
public:
  virtual VOID OutputES(FILE *fpOutputFile, 
			CHAR *paletteFilename,
			CHAR *colorFilename);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  virtual VOID FindMatrices(Matrix &m1, Matrix &m2, TilePoint *tpt1);

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:

};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//


#endif // __PENTADODECAHEDRON_H__
