#include "octile2.h"

//////////////////////////////////////////////////////////////////////
// OCTile2 Class
//

OCTile2::OCTile2()
{
  Vector v1, v2, v3, v4;
  FLOAT f;
  
  v1.Set( 0.0, 0.0, 1.0);
  v2.Set( 1.0, 1.0, 1.0);
  v3.Set( 0.0, 1.0, 1.0);
  v4.Set(-1.0, 1.0, 1.0);

  f = 1.0 / v2.Magnitude();

  v1 *= f;
  v2 *= f;
  v3 *= f;
  v4 *= f;

  // 2D
  m_pt2DTilePoint1.Set(v1[X], v1[Y], v1[Z]);
  m_pt2DTilePoint2.Set(v2[X], v2[Y], v2[Z]);
  m_pt2DTilePoint3.Set(v3[X], v3[Y], v3[Z]);
  m_pt2DTilePoint4.Set(v4[X], v4[Y], v4[Z]);

  Init();
}

OCTile2::~OCTile2()
{
}

///////////////////////////////////////////////////////////////////////////////

VOID OCTile2::FindMatrices(Matrix &m1, Matrix &m2, TilePoint *tpt1)
{
  Vector v;

  if( tpt1->GetType() != tpTILE )
    {
      m1 = tpt1->GetPartnerMatrix();
      m2 = (tpt1->GetPartner())->GetPartnerMatrix();
    }
  else if( tpt1->GetTilePoint() == 1 )
    {
      m1.SetRotateZ(DEGTORAD(90));
      m2.SetRotateZ(DEGTORAD(-90));
    }
  else if( tpt1->GetTilePoint() == 2 )
    {
      v.Set(0.0, 0.5, 0.5);
      m1.SetRotate(v, DEGTORAD(-180));
      m2.SetRotate(v, DEGTORAD(180));
    }
  else if( tpt1->GetTilePoint() == 3 )
    {
      v.Set(0.0, 0.5, 0.5);
      m1.SetRotate(v, DEGTORAD(180));
      m2.SetRotate(v, DEGTORAD(-180));
    }
  else if( tpt1->GetTilePoint() == 4 )
    {
      m1.SetRotateZ(DEGTORAD(-90));
      m2.SetRotateZ(DEGTORAD(90));
    }
  else
    {
      ASSERT(FALSE);
    }
}

///////////////////////////////////////////////////////////////////////////////

VOID OCTile2::OutputES(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "ocube tile 2\n\n" );

  m_pTile->OutputES(fpOutputFile);

  OutputESColor(fpOutputFile);
}
