
proc colorButton { bid } {
    global selectedColorIndex colorMouseButton
    
    set framename .main.f[subst $bid]
    set buttonname .main.f[subst $bid].b
    set selectedframename .main.f[subst $selectedColorIndex]

    if { $colorMouseButton == 1 } {
	# left mouse pressed
	#puts "Select Color $bid"

	$selectedframename config -relief flat
	$framename config -relief sunken

	set selectedColorIndex $bid

    } elseif { $colorMouseButton == 3 } {
	# right mouse pressed
	#puts "Edit Color $bid"

	set curColor [$buttonname cget -background]
	set newColor [tk_chooseColor -initialcolor $curColor]

	if { $newColor != "" } {
	    $buttonname config -background $newColor
	    $buttonname config -activebackground $newColor
	}
    }        
}

proc main { } {
    set rowwidth 20
    set r 0
    set c 0
    
    set color #808080

    for {set i 0} {$i < 60} {incr i} {
	set framename .main.f[subst $i] 
	
	frame $framename -borderwidth 3	-width 30 -height 30

	set buttonname .main.f[subst $i].b
	
	button $buttonname -background $color -activebackground $color \
		-command "colorButton $i"

	set cmdRight "set colorMouseButton 3; colorButton $i"
        set cmdLeft  "set colorMouseButton 1"

	bind $buttonname <Button-3> "$cmdRight"
	bind $buttonname <Button-1> "$cmdLeft"
	
	if { fmod($c,$rowwidth) == 0.0 } {
	    incr r
	    set c 0
	}
	
	#grid propagate $framename false
	grid $framename -row $r -col $c -padx 0 -pady 0 -sticky e,w,n,s

	grid $buttonname -row 0 -col 0

	incr c
    }
    pack .main -side top -fill x -expand true

    colorButton 0
}

global colorMouseButton
global selectedColorIndex

set colorMouseButton 1
set selectedColorIndex 0

frame .main



main


